﻿using System;
using System.Windows.Forms;


namespace Prova
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }


        PictureBox P;


        private void Form1_Load(object sender, EventArgs e)
        {
            tlp.Controls.Clear();

            tlp.RowCount = 3;
            tlp.ColumnCount = 4;

            // le celle devono adattarsi al loro contenuto ...
            tlp.AutoSize = true;
            tlp.AutoSizeMode = AutoSizeMode.GrowAndShrink;
        }


        private void PlsAppari_Click(object sender, EventArgs e)
        {
            int Riga = (int)nudR.Value;
            int Col = (int)nudC.Value;

            // Se non ci sono PictureBox nella cella indicata ...
            if (tlp.GetControlFromPosition(Col, Riga) == null)
            {
                // creo un controllo PictureBox DA CODICE ...
                P = new PictureBox();

                P.Image = Prova.Properties.Resources.Giallo;

                P.Width = 100;
                P.Height = 50;

                P.SizeMode = PictureBoxSizeMode.StretchImage;

                // azzera il margine fra la PictureBox e il bordo della cella ...
                P.Margin = new Padding(0);

                // aggiungi la PictureBox alla griglia ...
                tlp.Controls.Add(P);

                // imposta la posizione della PictureBox nella griglia ...
                tlp.SetRow(P, Riga);
                tlp.SetColumn(P, Col);

                // imposta DA CODICE gli eventi sulla PictureBox ...
                P.Click += P_Click;
                P.DoubleClick += P_DoubleClick;
            }
            else
                MessageBox.Show("Casella già occupata!");
        }


        private void P_DoubleClick(object sender, EventArgs e)
        {
            // recupera la PictureBox cliccata (parametro "sender") ...
            P = (PictureBox)sender;

            // recupera Riga e Colonna della PictureBox cliccata ...
            nudR.Value = tlp.GetRow(P);
            nudC.Value = tlp.GetColumn(P);

            // rimuovi dalla griglia la PictureBox cliccata ...
            tlp.Controls.Remove(P);
        }


        private void P_Click(object sender, EventArgs e)
        {
            P = (PictureBox)sender;

            nudR.Value = tlp.GetRow(P);
            nudC.Value = tlp.GetColumn(P);

            // modifica l'immagine associata alla PcictureBox cliccata ...
            P.Image = Prova.Properties.Resources.Verde;
        }


        private void PlsCambia_Click(object sender, EventArgs e)
        {
            int Riga = (int)nudR.Value;
            int Col = (int)nudC.Value;

            // se la cella indicata contiene davvero una PictureBox ...
            if (tlp.GetControlFromPosition(Col, Riga) != null)
            {
                // recupera la PictureBox che si trova in posizione Riga, Col
                P = (PictureBox)tlp.GetControlFromPosition(Col, Riga);

                P.Image = Prova.Properties.Resources.Rosso;
            }
            else
                MessageBox.Show("La casella " + Riga + "," + Col + " è vuota");
        }

        private void ChkBordi_CheckedChanged(object sender, EventArgs e)
        {
            if (chkBordi.Checked)
            { 
                tlp.CellBorderStyle = TableLayoutPanelCellBorderStyle.InsetDouble;
            }
            else
            {
                tlp.CellBorderStyle = TableLayoutPanelCellBorderStyle.None;
            }
        }
    }
}
